'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _prepend = require('prepend');

var _prepend2 = _interopRequireDefault(_prepend);

var _bluebird = require('bluebird');

var _bluebird2 = _interopRequireDefault(_bluebird);

var _ensureCleanLocalGitState = require('./ensureCleanLocalGitState');

var _ensureCleanLocalGitState2 = _interopRequireDefault(_ensureCleanLocalGitState);

var _getMergedPullRequests = require('./getMergedPullRequests');

var _getMergedPullRequests2 = _interopRequireDefault(_getMergedPullRequests);

var _createChangelog = require('./createChangelog');

var _createChangelog2 = _interopRequireDefault(_createChangelog);

var _getGithubRepo = require('./getGithubRepo');

var _getGithubRepo2 = _interopRequireDefault(_getGithubRepo);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var prependFile = _bluebird2.default.promisify(_prepend2.default);

function stripTrailingEmptyLine(text) {
    if (text.lastIndexOf('\n\n') === text.length - 2) {
        return text.slice(0, -1);
    }

    return text;
}

exports.default = {
    run: function run(newVersionNumber) {
        var packageConfig = require(_path2.default.join(process.cwd(), 'package.json'));
        var githubRepo = (0, _getGithubRepo2.default)(packageConfig.repository.url);
        var changelogPath = _path2.default.join(process.cwd(), 'CHANGELOG.md');

        if (!newVersionNumber) {
            throw new Error('version-number not specified');
        }

        return _bluebird2.default.try(_ensureCleanLocalGitState2.default.bind(null, githubRepo)).then(_getMergedPullRequests2.default.bind(null, githubRepo)).then(_createChangelog2.default.bind(null, newVersionNumber)).then(stripTrailingEmptyLine).then(prependFile.bind(null, changelogPath));
    }
};